﻿using Dss.Api.Examples.Internal;
using Dss.Api.Examples.Properties;
using System;
using DataScope.Select.Api.Authentication;
using DataScope.Select.Api.Users;

namespace Dss.Api.Examples.Authentication
{

    [Example("3. Authentication")]
    public class AuthorizationExamples
    {

        [Example("RequestToken")]
        [EndToEndExample(typeof(AuthenticationContext))]
        public void RequestToken()
        {
            ContextHelper.ClearToken();

            //var usersContext = ContextHelper.CreateUsersContext(false);
            //Status.Notify(usersContext, null, "RequestToken");

            //Store the session token for use on other contexts.  Storing and re-using the session token
            //will avoid unnecessary authentication requests and improve response times.
            //var sessionToken = usersContext.SessionToken;

            //Output
           // Status.WriteLine(sessionToken);
           // Status.EndNotify(usersContext);

            var authenticationContext = ContextHelper.CreateAuthenticationContext(false);
            Status.Notify(authenticationContext, null, "RequestToken", MethodType.Operation, Publish.Secondary);
            
            var sessionToken = authenticationContext.SessionToken;
            Status.WriteLine(sessionToken);
            Status.EndNotify(authenticationContext);

            //Status.Notify(usersContext, "User", "Get");
            ////Fetch the user information using the current token applied to the header.
            //usersContext.UserOperations.Get(int.Parse(Settings.Default.UserId));
            //Status.EndNotify(usersContext);
        }

        //[Example("Sharing Token's")]
        [EndToEndExample(typeof(AuthenticationContext))]
        public void SharingTokens()
        {
            var usersContext = ContextHelper.CreateUsersContext();
            Status.Notify(usersContext, null, "SessionToken");
            //Store the session token for use on other contexts.  Storing and re-using the session token
            //will avoid unnecessary authentication requests and improve response times.
            var sessionToken = usersContext.SessionToken;

            //Output
            Status.WriteLine(sessionToken);
            Status.EndNotify(usersContext);

            Status.Notify(usersContext, "User", "Get");
            //Create another context with the same token
            var usersContext2 = new UsersContext(new Uri(Settings.Default.ServiceUri), sessionToken);
            usersContext2.UserOperations.Get(int.Parse(Settings.Default.UserId));

            //Output
            Status.EndNotify(usersContext);
        }

    }

}
