﻿//using System;
//using System.Collections.Generic;
//using System.Collections.ObjectModel;
//using System.Reflection;
//using DataScope.Select.Api;
//using DataScope.Select.Api.Extractions;
//using DataScope.Select.Api.Extractions.ReportExtractions;
//using DataScope.Select.Api.Extractions.Schedules;

//namespace Dss.Api.Examples.Extractions.ReportExtractions
//{
    
//    public static class ScheduleOperationsExtensions
//    {

//        #region Immediate

//        /// <summary>
//        /// Creates a new (one time) schedule for extracting the data immediately.
//        /// </summary>
//        /// <param name="this"></param>
//        /// <param name="name">Name of the schedule</param>
//        /// <param name="listId">The ListId of either the instrument or entity list.</param>
//        /// <param name="reportTemplateId">The report template id.</param>
//        /// <param name="limitReportLimitToTodaysData">If true, the report will only return today's data.  For example, if the 
//        /// report template is requesting end of day data, but the end of day information for today is not available, no data will
//        /// be returned for that instrument or entity.  Use data availability triggers to define a schedule that waits until 
//        /// today's data is available.</param>
//        public static Schedule CreateImmediate(
//            this IScheduleOperations @this, string name, string listId, string reportTemplateId, 
//            bool limitReportLimitToTodaysData = false)
//        {
//            if (@this == null)
//                throw new ArgumentNullException("this");
//            var schedule = new Schedule
//                {
//                    Name = name,
//                    TimeZone = "Central Standard Time",
//                    Recurrence =
//                        new SingleRecurrence {ExtractionDateTime = DateTimeOffset.UtcNow, IsImmediate = true},
//                    Trigger = new ImmediateTrigger { LimitReportToTodaysData = limitReportLimitToTodaysData},
//                    ListId = listId,
//                    ReportTemplateId = reportTemplateId,
//                };
//            @this.Create(schedule);
//            return schedule;
//        }

//        #endregion

//        #region Single

//        /// <summary>
//        /// Creates a new (one time) schedule for extracting the data on a specific date and time.
//        /// </summary>
//        /// <param name="this"></param>
//        /// <param name="name">Name of the schedule</param>
//        /// <param name="listId">The ListId of either the instrument or entity list.</param>
//        /// <param name="reportTemplateId">The report template id.</param>
//        /// <param name="extractionDateTime">The date and time the extraction should run.</param>
//        /// <param name="limitReportLimitToTodaysData">If true, the report will only return today's data.  For example, if the 
//        /// report template is requesting end of day data, but the end of day information for today is not available, no data will
//        /// be returned for that instrument or entity.  Use data availability triggers to define a schedule that waits until 
//        /// today's data is available.</param>
//        public static Schedule CreateSingle(
//            this IScheduleOperations @this, string name, string listId, string reportTemplateId, 
//            DateTime extractionDateTime, bool limitReportLimitToTodaysData = false)
//        {
//            return @this.CreateSingle(
//                name, listId, reportTemplateId, extractionDateTime.Date,
//                new ObservableCollection<HourMinute> { HourMinute.Create(extractionDateTime.Hour, extractionDateTime.Minute) },
//                limitReportLimitToTodaysData);
//        }

//        /// <summary>
//        /// Creates a new (one time) schedule for extracting the data on a specific date and time(s).
//        /// </summary>
//        /// <param name="this"></param>
//        /// <param name="name">Name of the schedule</param>
//        /// <param name="listId">The ListId of either the instrument or entity list.</param>
//        /// <param name="reportTemplateId">The report template id.</param>
//        /// <param name="extractionDate">The date on which the extraction should run.</param>
//        /// <param name="extractionTimes">The time(s) for which the extraction should be run (maximum of 5).</param>
//        /// <param name="limitReportLimitToTodaysData">If true, the report will only return today's data.  For example, if the 
//        /// report template is requesting end of day data, but the end of day information for today is not available, no data will
//        /// be returned for that instrument or entity.  Use data availability triggers to define a schedule that waits until 
//        /// today's data is available.</param>
//        public static Schedule CreateSingle(
//            this IScheduleOperations @this, string name, string listId, string reportTemplateId,
//            DateTime extractionDate, IEnumerable<HourMinute> extractionTimes, bool limitReportLimitToTodaysData = false)
//        {
//            if (@this == null)
//                throw new ArgumentNullException("this");
//            var schedule = new Schedule
//            {
//                Name = name,
//                TimeZone = "Central Standard Time",
//                Recurrence = new SingleRecurrence { ExtractionDateTime = extractionDate },
//                Trigger = new TimeTrigger
//                {
//                    LimitReportToTodaysData = limitReportLimitToTodaysData,
//                    At = new DssCollection<HourMinute>(extractionTimes),
//                },
//                ListId = listId,
//                ReportTemplateId = reportTemplateId,
//            };
//            @this.Create(schedule);
//            return schedule;
//        }

//        /// <summary>
//        /// Creates a new (one time) schedule for extracting the data on a specific date and time.
//        /// </summary>
//        /// <param name="this"></param>
//        /// <param name="name">Name of the schedule</param>
//        /// <param name="listId">The ListId of either the instrument or entity list.</param>
//        /// <param name="reportTemplateId">The report template id.</param>
//        /// <param name="extractionDateTime"></param>
//        /// <param name="limitReportLimitToTodaysData">If true, the report will only return today's data.  For example, if the 
//        /// report template is requesting end of day data, but the end of day information for today is not available, no data will
//        /// be returned for that instrument or entity.  Use data availability triggers to define a schedule that waits until 
//        /// today's data is available.</param>
//        /// <param name="extendedInformation">Schedules that reference end of day, premium pricing or technical indicators
//        /// report templates may specify additional options which affect when and how the data availability is determined/triggered.
//        /// End of day report templates may indicate: error corrected or delta.  Premium pricing report templates may indicate to
//        /// wait for tolerance data.  Technical indicators may indicate whether relative analytics are used.  See the user guide
//        /// for detailed information.</param>
//        /// <param name="timeOut">Specifies the maximum time to wait for an extraction.</param>
//        public static Schedule CreateSingleTriggered(
//            this IScheduleOperations @this, string name, string listId, string reportTemplateId, DateTime extractionDateTime,
//            bool limitReportLimitToTodaysData = false, ExtendedTriggerInformation extendedInformation = null,
//            DataAvailabilityTriggerTimeout timeOut = null)
//        {
//            if (@this == null)
//                throw new ArgumentNullException("this");
//            var schedule = new Schedule
//            {
//                Name = name,
//                TimeZone = "Central Standard Time",
//                Recurrence = new SingleRecurrence { ExtractionDateTime = extractionDateTime },
//                Trigger = new DataAvailabilityTrigger
//                {
//                    ExtendedInformation = extendedInformation,
//                    LimitReportToTodaysData = limitReportLimitToTodaysData,
//                    TimeOut = timeOut
//                },
//                ListId = listId,
//                ReportTemplateId = reportTemplateId,
//            };
//            @this.Create(schedule);
//            return schedule;
//        }

//        #endregion

//        #region Weekly

//        /// <summary>
//        /// Creates a weekly schedule.
//        /// </summary>
//        /// <param name="this"></param>
//        /// <param name="name">Name of the schedule</param>
//        /// <param name="listId">The ListId of either the instrument or entity list.</param>
//        /// <param name="reportTemplateId">The report template id.</param>
//        /// <param name="daysOfWeek">The days of the week on which the schedule should run.</param>
//        /// <param name="limitReportLimitToTodaysData">If true, the report will only return today's data.  For example, if the 
//        /// report template is requesting end of day data, but the end of day information for today is not available, no data will
//        /// be returned for that instrument or entity.  Use data availability triggers to define a schedule that waits until 
//        /// today's data is available.</param>
//        /// <param name="extendedInformation">Schedules that reference end of day, premium pricing or technical indicators
//        /// report templates may specify additional options which affect when and how the data availability is determined/triggered.
//        /// End of day report templates may indicate: error corrected or delta.  Premium pricing report templates may indicate to
//        /// wait for tolerance data.  Technical indicators may indicate whether relative analytics are used.  See the user guide
//        /// for detailed information.</param>
//        /// <param name="timeOut">Specifies the maximum time to wait for an extraction.</param>
//        public static Schedule CreateWeeklyTriggered(
//            this IScheduleOperations @this, string name, string listId, string reportTemplateId, IEnumerable<DayOfWeek> daysOfWeek,
//            bool limitReportLimitToTodaysData = false, ExtendedTriggerInformation extendedInformation = null,
//            DataAvailabilityTriggerTimeout timeOut = null)
//        {
//            if (@this == null)
//                throw new ArgumentNullException("this");
//            var schedule = new Schedule
//            {
//                Name = name,
//                TimeZone = "Central Standard Time",
//                Recurrence = new WeeklyRecurrence { Days = new DssCollection<DayOfWeek>(daysOfWeek) },
//                Trigger = new DataAvailabilityTrigger
//                {
//                    ExtendedInformation = extendedInformation,
//                    LimitReportToTodaysData = limitReportLimitToTodaysData,
//                    TimeOut = timeOut
//                },
//                ListId = listId,
//                ReportTemplateId = reportTemplateId,
//            };
//            @this.Create(schedule);
//            return schedule;
//        }

//        #endregion

//        #region Monthly

//        /// <summary>
//        /// Creates a new monthly schedule.
//        /// </summary>
//        /// <param name="this"></param>
//        /// <param name="name">Name of the schedule</param>
//        /// <param name="listId">The ListId of either the instrument or entity list.</param>
//        /// <param name="reportTemplateId">The report template id.</param>
//        /// <param name="monthlyDay">The day of the month for which the extraction will run.  If the month does not have that day
//        /// of the month then the extraction will NOT run for that month.  Valid values are 1-28 and 32.  Use 32 to specify the 
//        /// last day of the month.  If multiple days of the month are required, separate schedules can be created.</param>
//        /// <param name="limitReportLimitToTodaysData">If true, the report will only return today's data.  For example, if the 
//        /// report template is requesting end of day data, but the end of day information for today is not available, no data will
//        /// be returned for that instrument or entity.  Use data availability triggers to define a schedule that waits until 
//        /// today's data is available.</param>
//        /// <param name="extendedInformation">Schedules that reference end of day, premium pricing or technical indicators
//        /// report templates may specify additional options which affect when and how the data availability is determined/triggered.
//        /// End of day report templates may indicate: error corrected or delta.  Premium pricing report templates may indicate to
//        /// wait for tolerance data.  Technical indicators may indicate whether relative analytics are used.  See the user guide
//        /// for detailed information.</param>
//        /// <param name="timeOut">Specifies the maximum time to wait for an extraction.</param>
//        public static Schedule CreateMonthlyTriggered(
//            this IScheduleOperations @this, string name, string listId, string reportTemplateId, int monthlyDay,
//            bool limitReportLimitToTodaysData = false, ExtendedTriggerInformation extendedInformation = null,
//            DataAvailabilityTriggerTimeout timeOut = null)
//        {
//            if (@this == null)
//                throw new ArgumentNullException("this");
//            var schedule = new Schedule
//            {
//                Name = name,
//                TimeZone = "Central Standard Time",
//                Recurrence = new MonthlyRecurrence { MonthlyDay = monthlyDay },
//                Trigger = new DataAvailabilityTrigger
//                {
//                    ExtendedInformation = extendedInformation,
//                    LimitReportToTodaysData = limitReportLimitToTodaysData,
//                    TimeOut = timeOut
//                },
//                ListId = listId,
//                ReportTemplateId = reportTemplateId,
//            };
//            @this.Create(schedule);
//            return schedule;
//        }

//        #endregion

//        #region WaitForNextExtraction

//        /// <summary>
//        /// Waits until a 
//        /// </summary>
//        /// <param name="this"></param>
//        /// <param name="schedule"></param>
//        /// <param name="pollSeconds"></param>
//        /// <param name="timeOut"></param>
//        /// <returns></returns>
//        public static ReportExtraction WaitForNextExtraction(
//            this IScheduleOperations @this, Schedule schedule, int pollSeconds = 5, TimeSpan timeOut = default(TimeSpan))
//        {
//            if (@this == null)
//                throw new ArgumentNullException("this");
//            if (schedule == null)
//                throw new ArgumentNullException("schedule");

//            //Get the context
//            var propertyInfo = @this.GetType().GetField("_context", BindingFlags.Instance | BindingFlags.NonPublic);
//            var context = (ExtractionsContext)propertyInfo.GetValue(@this);

//            var mustBeLaterThan = DateTimeOffset.UtcNow.Subtract(TimeSpan.FromMinutes(5));
//            timeOut = (timeOut == TimeSpan.Zero) ? TimeSpan.FromMinutes(60) : timeOut;
//            var startTime = DateTimeOffset.UtcNow;
//            var timeOutTime = startTime.Add(timeOut);
//            bool extractionReady;

//            ReportExtraction reportExtraction;
//            do
//            {
//                //Sleep
//                System.Threading.Thread.Sleep(pollSeconds * 1000);
//                //Fetch the last extraction
//                reportExtraction = context.ReportExtractionOperations.GetLastExtractionForScheduleId(schedule.ScheduleId);
//                //context.LoadProperty(schedule, "LastExtraction");
//                //reportExtraction = schedule.LastExtraction;
//                //Is it ready for download?
//                extractionReady =
//                    reportExtraction != null
//                    && reportExtraction.Status == ReportExtractionStatus.Completed
//                    && reportExtraction.ExtractionDateUtc > mustBeLaterThan;
//            } while (!extractionReady && (DateTimeOffset.UtcNow < timeOutTime));

//            //Timeout
//            if (!extractionReady)
//                throw new TimeoutException("Extraction took too long");

//            //Return
//            return reportExtraction;
//        }
//        #endregion

//    }

//}
